// NativeWrapperDemo.cpp : Definiert den Einstiegspunkt fr die Konsolenanwendung.
//

#include "stdafx.h"

#include <iostream>
#include <conio.h>

#include <Windows.h>

using namespace std;

void waitkey(char *prompt)
{
#ifndef NO_KEY_WAIT
  cout << "Hit any key to " << prompt << "..." << endl;
  _getch();
#endif
}

int _tmain(int argc, _TCHAR* argv[])
{
  waitkey("load wrapper DLL");
  HMODULE hdll = LoadLibrary(_T("NativeWrapper.dll"));
  _ASSERT(hdll);
  FARPROC NativeHelloWrapper = GetProcAddress(hdll, "_NativeHelloWrapper@0");
  _ASSERT(NativeHelloWrapper);
  cout << "Have a nice native program run! :)" << endl;
  waitkey("call wrapped lib function");
  NativeHelloWrapper();
  cout << "Back in the native world." << endl;
  waitkey("unload wrapped lib");
  FARPROC UnloadManagedLib = GetProcAddress(hdll, "_UnloadManagedLib@0");
  _ASSERT(UnloadManagedLib);
  UnloadManagedLib();
  waitkey("unload wrapper lib");
  _ASSERT(FreeLibrary(hdll));
  waitkey("quit");
  return 0;
}

